var killfeeds = [];

/**
* Adds text to the killfeed with a delay
* @param text the text to add
* @param delay the delay before the text starts to fade
*/
function killfeed(text, delay) {
  killfeeds.push(new Killfeed(text, delay));
}

/**
* Adds text to the killfeed with the default delay of 2 seconds
* @param text the text to add
*/
function killfeed(text) {
  killfeeds.push(new Killfeed(text, 120));
}

// draw killfeed on screen
register("renderOverlay", function() {
  for (var i = 0; i < killfeeds.length; i++) {
    killfeeds[i].draw(5 + i * 10);
  }
});

// update killfeed
register("step", function() {
  for (var i = 0; i < killfeeds.length; i++) {
    killfeeds[i].update();
    if (killfeeds[i].delay <= 0) {
      killfeeds.splice(i, 1);
    }
  }
});

// killfeed object
function Killfeed(text, delay) {
  this.text = new Text(ChatLib.addColor(text), 5, 0);
  this.delay = delay;
  this.alpha = 255;
  this.background = new Rectangle(0, 4, 0, Renderer.getStringWidth(this.text.getString()) + 1, 10);

  this.draw = function(y) {
    this.background.setColor(Renderer.color(0, 0, 0, this.alpha / 3))
      .setY(y - 1).draw();

    this.text
      .setColor(Renderer.color(255, 255, 255, this.alpha))
      .setY(y).draw();
  }

  this.update = function() {
    this.delay--;
    if (this.delay * 4 < 255) {
      this.alpha = this.delay * 4;
    }
    if (this.alpha < 8) {
      this.alpha = 8;
    }
  }
}
