var notifies = [];

/**
* Creates a new notification object to slide on and off screen
* with a set delay of 30.
* @param text the text to draw on screen
*/
function notify(text) {
	for (var i=0; i<notifies.length; i++) {
		if (notifies[i] == null) {
			notifies[i] = new Notify(text, i, 30);
			return;
		}
	}
	notifies.push(new Notify(txt, notifies.length, 30));
}

/**
* Creates a new notification object to slide on and off screen
* with a delay.
* @param text the text to draw on screen
* @param delay the delay before the text starts moving back off screen
*/
function notify(text, delay) {
	for (var i=0; i<notifies.length; i++) {
		if (notifies[i] == null) {
			notifies[i] = new Notify(text, i, delay);
			return;
		}
	}
	notifies.push(new Notify(text, notifies.length, delay));
}


// draws all notify objects
register("renderOverlay", function() {
	for (var i=0; i<notifies.length; i++) {
		if (notifies[i] != null) {
			notifies[i].draw();
		}
	}
});

// updates all notify objects
register("step", function() {
	for (var i=0; i<notifies.length; i++) {
		if (notifies[i] != null) {
			notifies[i].update();
		}
	}
}).setFps(120);

// notify object
function Notify(text, index, delay) {
	// static values
	this.index = index;
	this.delay = delay;

	// position
	this.x = Renderer.screen.getWidth();
	this.y = Renderer.screen.getHeight() - 50 - (this.index * 12);

	// dynamic values
	this.step = 0;
	this.xspeed = 0;
	this.text = new Text(ChatLib.addColor(text), 0, this.y);
	this.background = new Rectangle(0x80000000, 0, this.y - 1, Renderer.getStringWidth(this.text.getString()) + 2, 10);

	// draw notify
	this.draw = function() {
		// background
		this.background.setX(this.x - 1).draw();

		// text
		this.text.setX(this.x).draw();
	}

	// update notify
	this.update = function() {
		if (this.step == 0) {
			// easeOut onto screen
			this.x = easeOut(
				this.x,
				Renderer.screen.getWidth() - Renderer.getStringWidth(this.text.getString()) - 10,
				15, 0.1
			);

			// move step once on screen
			if (this.x == Renderer.screen.getWidth() - Renderer.getStringWidth(this.text.getString()) - 10) {
				this.step = 1
			}
		} else if (this.step <= this.delay) {
			// pause on screen
			this.step++;
		} else {
			// move off screen
			this.x += this.xspeed;
			this.xspeed += 0.05;

			// set index to null when off screen
			if (this.x > Renderer.screen.getWidth()) {
				notifies[this.index] = null;
			}
		}
	}
}
